/******************************************************************************
 * GViD Source Code Editor
 * Copyright (C) 2002  Alan Oursland
 * 
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * 
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 * 
 * Alan Oursland
 * alan@oursland.net
 *****************************************************************************/
import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import gvid.ui.editor.*;
import gvid.ui.splitscrollpane.*;
import java.awt.datatransfer.Clipboard;

public class GViD {
	
	public static void main( String[] args ) {
		String filename = "gvid/ui/editor/SourceCodeView.java";

		if( args.length > 0 ) {
			filename = args[0];
		}

		try {
//			  UIManager.setLookAndFeel("com.sun.java.swing.plaf.windows.WindowsLookAndFeel");
//			  com.sun.java.swing.plaf.windows.WindowsLookAndFeel laf = new com.sun.java.swing.plaf.windows.WindowsLookAndFeel();
			LookAndFeel laf = new com.sun.java.swing.plaf.windows.WindowsLookAndFeel() {
				public boolean isNativeLookAndFeel() {
					return true;
				}
			};
			UIManager.setLookAndFeel(laf);
		} catch( Exception e ) {
			System.err.println(e);
		}

//		gvid.ui.editor.SourceCodeView scv = test.gvid.ui.editor.SourceCodeView.buildSourceCodeView();
		SourceCodeView scv = new SourceCodeView();
//		scv.loadFile(filename);
//		scv.setCaretPosition(3,0);
//		scv.setSelectionPosition(new Point(5,8), SourceCodeSelection.BOUNDED);
		
		
		final JFrame f = new JFrame();
		f.getContentPane().setLayout(new BorderLayout());
		f.addWindowListener(new WindowAdapter() {
				public void windowClosing(WindowEvent e) {
					f.dispose();
				}

				public void windowClosed(WindowEvent e) {
					System.exit(0);
				}
			});

		SplitScrollPane sp = new SplitScrollPane();
		sp.setView(scv);
		f.getContentPane().add( sp, BorderLayout.CENTER );
		
		f.setSize(600,700);
		f.doLayout();

		f.setVisible(true);
		
		return;
	}
}