/******************************************************************************
 * GViD Source Code Editor
 * Copyright (C) 2002  Alan Oursland
 * 
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * 
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 * 
 * Alan Oursland
 * alan@oursland.net
 *****************************************************************************/
package gvid.project;

import gvid.ui.*;
import javax.swing.*;
import java.beans.*;
import java.awt.*;
import java.io.File;
import java.awt.event.*;
import gvid.util.TableListModel;

public class ProjectSettingsPanel extends javax.swing.JPanel 
	implements ActionListener {
	public ProjectSettingsPanel() {
//		m_classpathList.getTableHeader().setVisible(false);
		m_classpathList.getTableHeader().setReorderingAllowed(false);
		
		//{{INIT_CONTROLS
		setLayout(new GridBagLayout());
		setSize(616,217);
		m_classLabel.setText("Main Class:");
		add(m_classLabel, new GridBagConstraints(0,1,2,1,0.0,0.0,java.awt.GridBagConstraints.EAST,java.awt.GridBagConstraints.NONE,new Insets(0,0,0,0),0,0));
		m_classLabel.setForeground(java.awt.Color.black);
		m_argsLabel.setText("Arguments:");
		add(m_argsLabel, new GridBagConstraints(0,2,2,1,0.0,0.0,java.awt.GridBagConstraints.EAST,java.awt.GridBagConstraints.NONE,new Insets(0,0,0,0),0,0));
		m_argsLabel.setForeground(java.awt.Color.black);
		m_classField.setColumns(20);
		add(m_classField, new GridBagConstraints(2,1,2,1,0.0,0.0,java.awt.GridBagConstraints.WEST,java.awt.GridBagConstraints.HORIZONTAL,new Insets(0,0,0,0),0,0));
		m_argsField.setColumns(20);
		add(m_argsField, new GridBagConstraints(2,2,2,1,0.0,0.0,java.awt.GridBagConstraints.WEST,java.awt.GridBagConstraints.HORIZONTAL,new Insets(0,0,0,0),0,0));
		m_debugOption.setText("Debug");
		m_debugOption.setActionCommand("Debug");
		add(m_debugOption, new GridBagConstraints(2,3,1,1,0.0,0.0,java.awt.GridBagConstraints.EAST,java.awt.GridBagConstraints.NONE,new Insets(0,0,0,0),0,0));
		m_releaseOption.setText("Release");
		m_releaseOption.setActionCommand("Release");
		add(m_releaseOption, new GridBagConstraints(3,3,1,1,0.0,0.0,java.awt.GridBagConstraints.WEST,java.awt.GridBagConstraints.NONE,new Insets(0,0,0,0),0,0));
		m_srcLabel.setText("Source Root:");
		add(m_srcLabel, new GridBagConstraints(0,4,2,1,0.0,0.0,java.awt.GridBagConstraints.EAST,java.awt.GridBagConstraints.NONE,new Insets(0,0,0,0),0,0));
		m_srcLabel.setForeground(java.awt.Color.black);
		m_dstLabel.setText("Build Destination:");
		add(m_dstLabel, new GridBagConstraints(0,5,2,1,0.0,0.0,java.awt.GridBagConstraints.EAST,java.awt.GridBagConstraints.NONE,new Insets(0,0,0,0),0,0));
		m_dstLabel.setForeground(java.awt.Color.black);
		m_docLabel.setText("Document Root:");
		add(m_docLabel, new GridBagConstraints(0,6,2,1,0.0,0.0,java.awt.GridBagConstraints.EAST,java.awt.GridBagConstraints.NONE,new Insets(0,0,0,0),0,0));
		m_docLabel.setForeground(java.awt.Color.black);
		m_jarLabel.setText("Jar File Destination:");
		add(m_jarLabel, new GridBagConstraints(0,7,2,1,0.0,0.0,java.awt.GridBagConstraints.EAST,java.awt.GridBagConstraints.NONE,new Insets(0,0,0,0),0,0));
		m_jarLabel.setForeground(java.awt.Color.black);
		m_jdkLabel.setText("JDK Root:");
		add(m_jdkLabel, new GridBagConstraints(0,8,2,1,0.0,0.0,java.awt.GridBagConstraints.EAST,java.awt.GridBagConstraints.NONE,new Insets(0,0,0,0),0,0));
		m_jdkLabel.setForeground(java.awt.Color.black);
		m_srcField.setColumns(20);
		add(m_srcField, new GridBagConstraints(2,4,2,1,0.0,0.0,java.awt.GridBagConstraints.WEST,java.awt.GridBagConstraints.HORIZONTAL,new Insets(0,0,0,0),0,0));
		m_dstField.setColumns(20);
		add(m_dstField, new GridBagConstraints(2,5,2,1,0.0,0.0,java.awt.GridBagConstraints.WEST,java.awt.GridBagConstraints.HORIZONTAL,new Insets(0,0,0,0),0,0));
		m_docField.setColumns(20);
		add(m_docField, new GridBagConstraints(2,6,2,1,0.0,0.0,java.awt.GridBagConstraints.WEST,java.awt.GridBagConstraints.HORIZONTAL,new Insets(0,0,0,0),0,0));
		m_jarField.setColumns(20);
		add(m_jarField, new GridBagConstraints(2,7,2,1,0.0,0.0,java.awt.GridBagConstraints.WEST,java.awt.GridBagConstraints.HORIZONTAL,new Insets(0,0,0,0),0,0));
		m_jdkField.setColumns(20);
		add(m_jdkField, new GridBagConstraints(2,8,2,1,0.0,0.0,java.awt.GridBagConstraints.WEST,java.awt.GridBagConstraints.HORIZONTAL,new Insets(0,0,0,0),0,0));
		m_buildDocs.setText("Build Docs");
		m_buildDocs.setActionCommand("Build Docs");
		add(m_buildDocs, new GridBagConstraints(2,9,1,1,0.0,0.0,java.awt.GridBagConstraints.EAST,java.awt.GridBagConstraints.NONE,new Insets(0,0,0,0),0,0));
		m_buildJars.setText("Build Jar");
		m_buildJars.setActionCommand("Build Jar");
		add(m_buildJars, new GridBagConstraints(3,9,1,1,0.0,0.0,java.awt.GridBagConstraints.WEST,java.awt.GridBagConstraints.NONE,new Insets(0,0,0,0),0,0));
		m_classpathPanel.setLayout(new BorderLayout(0,0));
		add(m_classpathPanel, new GridBagConstraints(5,0,4,10,0.0,0.0,java.awt.GridBagConstraints.CENTER,java.awt.GridBagConstraints.BOTH,new Insets(5,5,5,5),0,0));
		m_classpathPanel.setBackground(new java.awt.Color(204,204,204));
		m_listScroll.setOpaque(true);
		m_classpathPanel.add(BorderLayout.CENTER, m_listScroll);
		m_classpathList.setModel(m_classpathTableModel);
		m_classpathList.setCellSelectionEnabled(true);
		m_classpathList.setPreferredScrollableViewportSize(new java.awt.Dimension(600,500));
		m_classpathList.setShowVerticalLines(false);
		m_classpathList.setAutoResizeMode(javax.swing.JTable.AUTO_RESIZE_ALL_COLUMNS);
		m_classpathList.setGridColor(new java.awt.Color(153,153,153));
		m_classpathList.setDoubleBuffered(true);
		m_listScroll.getViewport().add(m_classpathList);
		m_classpathList.setBounds(0,0,321,0);
		m_buttonPanel.setLayout(new GridLayout(1,4,0,0));
		m_classpathPanel.add(BorderLayout.SOUTH, m_buttonPanel);
		m_addButton.setText("Add");
		m_addButton.setActionCommand("Add");
		m_buttonPanel.add(m_addButton);
		m_removeButton.setText("Remove");
		m_removeButton.setActionCommand("Remove");
		m_buttonPanel.add(m_removeButton);
		m_orderUpButton.setText("Up");
		m_orderUpButton.setActionCommand("Up");
		m_buttonPanel.add(m_orderUpButton);
		m_orderDownButton.setText("Down ");
		m_orderDownButton.setActionCommand("Down ");
		m_buttonPanel.add(m_orderDownButton);
		//$$ m_classpathTableModel.move(0,0);
		//}}

		//{{REGISTER_LISTENERS
		//}}
		m_addButton.addActionListener(this);
		m_removeButton.addActionListener(this);
		m_orderUpButton.addActionListener(this);
		m_orderDownButton.addActionListener(this);
		
		m_buildGroup.add( m_debugOption );
		m_buildGroup.add( m_releaseOption );
	}

	//{{DECLARE_CONTROLS
	javax.swing.JLabel m_classLabel = new javax.swing.JLabel();
	javax.swing.JLabel m_argsLabel = new javax.swing.JLabel();
	javax.swing.JTextField m_classField = new javax.swing.JTextField();
	javax.swing.JTextField m_argsField = new javax.swing.JTextField();
	javax.swing.JRadioButton m_debugOption = new javax.swing.JRadioButton();
	javax.swing.JRadioButton m_releaseOption = new javax.swing.JRadioButton();
	javax.swing.JLabel m_srcLabel = new javax.swing.JLabel();
	javax.swing.JLabel m_dstLabel = new javax.swing.JLabel();
	javax.swing.JLabel m_docLabel = new javax.swing.JLabel();
	javax.swing.JLabel m_jarLabel = new javax.swing.JLabel();
	javax.swing.JLabel m_jdkLabel = new javax.swing.JLabel();
	javax.swing.JTextField m_srcField = new javax.swing.JTextField();
	javax.swing.JTextField m_dstField = new javax.swing.JTextField();
	javax.swing.JTextField m_docField = new javax.swing.JTextField();
	javax.swing.JTextField m_jarField = new javax.swing.JTextField();
	javax.swing.JTextField m_jdkField = new javax.swing.JTextField();
	javax.swing.JCheckBox m_buildDocs = new javax.swing.JCheckBox();
	javax.swing.JCheckBox m_buildJars = new javax.swing.JCheckBox();
	javax.swing.JPanel m_classpathPanel = new javax.swing.JPanel();
	javax.swing.JScrollPane m_listScroll = new javax.swing.JScrollPane();
	javax.swing.JTable m_classpathList = new javax.swing.JTable();
	javax.swing.JPanel m_buttonPanel = new javax.swing.JPanel();
	javax.swing.JButton m_addButton = new javax.swing.JButton();
	javax.swing.JButton m_removeButton = new javax.swing.JButton();
	javax.swing.JButton m_orderUpButton = new javax.swing.JButton();
	javax.swing.JButton m_orderDownButton = new javax.swing.JButton();
	gvid.util.TableListModel m_classpathTableModel = new gvid.util.TableListModel();
	//}}
	
	ButtonGroup m_buildGroup = new ButtonGroup();

	public void initSettings( ProjectModel project ) {
		m_classField.setText( project.getMainClass() );
		m_classField.setText( project.getArgs() );
		if( project.getReleaseType() == ProjectModel.DEBUG ) {
			m_debugOption.setSelected(true);
		} else {
			m_releaseOption.setSelected(true);
		}		
		m_srcField.setText(project.getSourceRoot().getAbsolutePath());
		m_dstField.setText(project.getDestinationRoot().getAbsolutePath());
		m_docField.setText(project.getDocRoot().getAbsolutePath());
		m_jarField.setText(project.getJarRoot().getAbsolutePath());
		File jdkRoot = project.getJDKRoot();
		if( jdkRoot == null ) {
			m_jdkField.setText("");
		} else {
			m_jdkField.setText(jdkRoot.getAbsolutePath());
		}
		m_buildDocs.setSelected(project.getBuildDocs());
		m_buildJars.setSelected(project.getBuildJar());
		m_classpathTableModel.clear();
		m_classpathTableModel.addAll(project.getClasspath());				
	}
	
	public void extractSettings( ProjectModel project ) {
		project.setMainClass( m_classField.getText() );
		project.setArgs( m_classField.getText() );
		if( m_debugOption.isSelected() ) {
			project.setReleaseType( ProjectModel.DEBUG );
		} else {
			project.setReleaseType( ProjectModel.FINAL );
		}		
		project.setSourceRoot(new File(m_srcField.getText()));
		project.setDestinationRoot(new File(m_dstField.getText()));
		project.setDocRoot(new File(m_docField.getText()));
		project.setJarRoot(new File(m_jarField.getText()));
		project.setJdkRoot(new File(m_jdkField.getText()));
		project.setBuildDocs(m_buildDocs.isSelected());
		project.setBuildJar(m_buildJars.isSelected());
		if( !m_classpathTableModel.listEquals(project.getClasspath()) ) {
			m_classpathTableModel.setList( project.getClasspath() );
		}
	}

    public void actionPerformed(ActionEvent e) {
    	Object src = e.getSource();
    	if( src == m_addButton ) {
    		m_classpathTableModel.addItem();
    	} else if( src == m_removeButton ) {
    		int sel = m_classpathList.getSelectedRow();
    		if( sel != -1 ) {
    			m_classpathTableModel.removeItem(sel);
    			if( sel >= m_classpathList.getRowCount() ) {
    				m_classpathList.setRowSelectionInterval(m_classpathList.getRowCount()-1, m_classpathList.getRowCount()-1);
    			}
    		}
    	} else if( src == m_orderUpButton ) {
    		int sel = m_classpathList.getSelectedRow();
    		if( sel > 0 ) {
    			m_classpathTableModel.moveItemUp(sel);
    			m_classpathList.setRowSelectionInterval( sel-1, sel-1 );
    		}
    	} else if( src == m_orderDownButton ) {
    		int sel = m_classpathList.getSelectedRow();
    		if( sel != -1 && sel < m_classpathList.getRowCount()-1 ) {
    			m_classpathTableModel.moveItemDown(sel);
    			m_classpathList.setRowSelectionInterval( sel+1, sel+1 );
    		}
    	}
    }
}
