/******************************************************************************
 * GViD Source Code Editor
 * Copyright (C) 2002  Alan Oursland
 * 
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * 
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 * 
 * Alan Oursland
 * alan@oursland.net
 *****************************************************************************/
package gvid.ui.editor;

import java.util.*;
import java.awt.*;

public class EditCaretEvent extends java.util.EventObject
{
    public static final int POSITIONCHANGE = 0x01;
    public static final int MODECHANGE = 0x02;
    
    private int m_type = 0;
    private Point m_position = null;
    private int m_mode = 0;
	public EditCaretEvent(Object source, int typeFlags, Point newPosition, int newMode ) { 
	    super(source);
	    m_type = typeFlags;
	    m_position = newPosition;
	    m_mode = newMode;
	}	
	
	public boolean isPositionChange() {
	    return (m_type&POSITIONCHANGE)!=0;
	}
	
	public boolean isModeChange() {
	    return (m_type&MODECHANGE)!=0;
	}
	
	public int getMode() {
	    return m_mode;
	}
	
	public Point getPosition() {
	    return new Point(m_position);
	}

	
    /**
     * Returns a String representation of this EditCaretEvent.
     *
     * @return  a String representation of this EditCaretEvent.
     */
    public String toString() {
        return getClass().getName() + "[source=" + source + ", type="+m_type+", position="+m_position+", mode="+m_mode+"]";
    }
}