/******************************************************************************
 * GViD Source Code Editor
 * Copyright (C) 2002  Alan Oursland
 * 
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * 
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 * 
 * Alan Oursland
 * alan@oursland.net
 *****************************************************************************/
package gvid.ui.editor.font;

import java.awt.*;

import java.awt.geom.AffineTransform;
import java.text.*;
import java.awt.font.*;
import java.awt.peer.FontPeer;
import java.util.*;
import java.text.AttributedCharacterIterator.Attribute;
import java.awt.geom.*;
public class FixedCourierFont extends java.awt.Font
{
	private static FontMetrics m_fontMetrics = new FixedCourierFontMetrics();
	
	public FixedCourierFont() {
		super("Courier Fixed", Font.PLAIN, 13);
	}
	
    public boolean equals(Object obj) {
        return (obj instanceof FixedCourierFont);
    }

    public void finalize() throws Throwable {
    }

    public byte getBaselineFor(char c) {
        return 11;
    }

    public String getFamily() {
        return "Courier";
    }

    public String getFamily(Locale l) {
        return getFamily();
    }

    public String getFontName() {
        return getFamily();
    }

    public String getFontName(Locale l) {
        return getFamily();
    }

    public float getItalicAngle() {
        return 0.0f;
    }

    public Rectangle2D getMaxCharBounds(FontRenderContext frc) {
        return new Rectangle(8, 13);
    }

    public String getName() {
        return getFamily();
    }

    public int getSize() {
        return 13;
    }

    public float getSize2D() {
        return 13.0f;
    }

    public int getNumGlyphs() {
        // This method is derived from class java.awt.Font
        // to do: code goes here
        return 224;
    }

    public String getPSName() {
    	// this font has no postscript name
        return super.getPSName();
    }
/*
    public FontPeer getPeer() {
        // deprecated - now platform independent
        return super.getPeer();
    }
*/
    public int getStyle() {
        return Font.PLAIN;
    }

    public boolean isBold() {
        return false;
    }

    public boolean isItalic() {
        return false;
    }

    public boolean isPlain() {
        return true;
    }

    public Map getAttributes() {
        return super.getAttributes();
    }

    public Attribute[] getAvailableAttributes() {
        return super.getAvailableAttributes();
    }
    
    public boolean hasUniformLineMetrics() {
        return true;
    }
   
///////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////

    public boolean canDisplay(char c)
    {
        // This method is derived from class java.awt.Font
        // to do: code goes here
        return false;
    }

    public int canDisplayUpTo(CharacterIterator iter, int start, int limit)
    {
        // This method is derived from class java.awt.Font
        // to do: code goes here
        return 0;
    }

    public int canDisplayUpTo(String str)
    {
        // This method is derived from class java.awt.Font
        // to do: code goes here
        return 0;
    }

    public int canDisplayUpTo(char text[], int start, int limit)
    {
        // This method is derived from class java.awt.Font
        // to do: code goes here
        return 0;
    }

    public GlyphVector createGlyphVector(FontRenderContext frc, char chars[])
    {
        // This method is derived from class java.awt.Font
        // to do: code goes here
        return null;
    }

    public GlyphVector createGlyphVector(FontRenderContext frc, CharacterIterator ci)
    {
        // This method is derived from class java.awt.Font
        // to do: code goes here
        return null;
    }

    public GlyphVector createGlyphVector(FontRenderContext frc, int glyphCodes[])
    {
        // This method is derived from class java.awt.Font
        // to do: code goes here
        return null;
    }

    public GlyphVector createGlyphVector(FontRenderContext frc, String str)
    {
        // This method is derived from class java.awt.Font
        // to do: code goes here
        return null;
    }

    public Font deriveFont(AffineTransform trans)
    {
        // This method is derived from class java.awt.Font
        // to do: code goes here
        return null;
    }

    public Font deriveFont(float size)
    {
        // This method is derived from class java.awt.Font
        // to do: code goes here
        return null;
    }

    public Font deriveFont(int style, AffineTransform trans)
    {
        // This method is derived from class java.awt.Font
        // to do: code goes here
        return null;
    }

    public Font deriveFont(int style)
    {
        // This method is derived from class java.awt.Font
        // to do: code goes here
        return null;
    }

    public Font deriveFont(Map attributes)
    {
        // This method is derived from class java.awt.Font
        // to do: code goes here
        return null;
    }

    public Font deriveFont(int style, float size)
    {
        // This method is derived from class java.awt.Font
        // to do: code goes here
        return null;
    }

    public LineMetrics getLineMetrics(String str, FontRenderContext frc)
    {
        // This method is derived from class java.awt.Font
        // to do: code goes here
        return null;
    }

    public LineMetrics getLineMetrics(String str, int beginIndex, int limit, FontRenderContext frc)
    {
        // This method is derived from class java.awt.Font
        // to do: code goes here
        return null;
    }

    public LineMetrics getLineMetrics(char chars[], int beginIndex, int limit, FontRenderContext frc)
    {
        // This method is derived from class java.awt.Font
        // to do: code goes here
        return null;
    }

    public LineMetrics getLineMetrics(CharacterIterator ci, int beginIndex, int limit, FontRenderContext frc)
    {
        // This method is derived from class java.awt.Font
        // to do: code goes here
        return null;
    }

    public int getMissingGlyphCode()
    {
        // This method is derived from class java.awt.Font
        // to do: code goes here
        return 0;
    }

    public Rectangle2D getStringBounds(String str, int beginIndex, int limit, FontRenderContext frc)
    {
        // This method is derived from class java.awt.Font
        // to do: code goes here
        return null;
    }

    public Rectangle2D getStringBounds(char chars[], int beginIndex, int limit, FontRenderContext frc)
    {
        // This method is derived from class java.awt.Font
        // to do: code goes here
        return null;
    }

    public Rectangle2D getStringBounds(String str, FontRenderContext frc)
    {
        // This method is derived from class java.awt.Font
        // to do: code goes here
        return null;
    }

    public Rectangle2D getStringBounds(CharacterIterator ci, int beginIndex, int limit, FontRenderContext frc)
    {
        // This method is derived from class java.awt.Font
        // to do: code goes here
        return null;
    }

    public AffineTransform getTransform()
    {
        // This method is derived from class java.awt.Font
        // to do: code goes here
        return null;
    }

    public int hashCode()
    {
        // This method is derived from class java.awt.Font
        // to do: code goes here
        return super.hashCode();
    }

    public String toString()
    {
        // This method is derived from class java.awt.Font
        // to do: code goes here
        return super.toString();
    }

	private static class FixedCourierFontMetrics extends java.awt.FontMetrics {
		
		public FixedCourierFontMetrics() {
			this(new FixedCourierFont());
		}
		
		public FixedCourierFontMetrics(FixedCourierFont font) {
			super(font);
		}
		
		public int getAscent() {
			return 11;
		}
		
		public int getLeading() {
			return 0;
		}
		
		public int getMaxAdvance() {
			return 8;
		}
		
		public int charWidth(char c) {
			return 8;
		}
		
		public int charsWidth(char[] data, int off, int len) {
			return 8*((off+len<data.length) ? len : data.length-off);
		}		
	}
}