/******************************************************************************
 * GViD Source Code Editor
 * Copyright (C) 2002  Alan Oursland
 * 
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * 
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 * 
 * Alan Oursland
 * alan@oursland.net
 *****************************************************************************/
package gvid.ui.editor.selection;

import gvid.ui.editor.SourceCodeEditor;
import java.awt.Point;
import java.awt.Cursor;
import java.awt.datatransfer.*;
import java.awt.dnd.*;
import java.awt.Component;
import gvid.undo.*;

public interface SourceCodeSelection 
	extends	Transferable, 
			ClipboardOwner,
			DragGestureListener,
			DragSourceListener
{
	public static final int BOUNDED = 0;
	public static final int BLOCKED = 1;
	public static final int LINE = 2;
	
	public int getSelectionType();
	public void setSelectionStart(java.awt.Point selEnd);
	public void setSelectionEnd(java.awt.Point selEnd);
	public java.awt.Point getSelectionEnd();
	public java.awt.Point getSelectionStart();
//	public void paint( java.awt.Graphics g );
	public SourceCodeSelection createCopy(SourceCodeEditor editor);
	public void updateBounds();
	public void swapAnchor();
	
    public UndoCommand paste( SourceCodeEditor editor, Point dest );
    public UndoCommand delete();
	
    public boolean contains( int x, int y );
    public boolean contains( Point p );
    public boolean containsPos( Point pos );
    public Point getLocation();
    public void setCursor(Cursor cursor);
    
    public SourceCodeSelection copy();
    public String getSelectedText();
    
    public UndoCommand toUppercase();
    public UndoCommand toLowercase();
    public UndoCommand toggleCase();
    
    public Component asComponent();
}