/******************************************************************************
 * GViD Source Code Editor
 * Copyright (C) 2002  Alan Oursland
 * 
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * 
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 * 
 * Alan Oursland
 * alan@oursland.net
 *****************************************************************************/
package gvid.ui.editor.undo;

import gvid.undo.*;

public class DragAndDropCommand extends gvid.undo.UndoChain
{
	private Object m_id = "";
	public DragAndDropCommand(String name, Object id ) {
		super(name);
		m_id = id;
	}
	
	public Object getId() {
		return m_id;
	}
	
    public boolean combineCommands( UndoCommand cmd ) {
    	boolean rc = false;
    	if( m_id!=null && cmd instanceof DragAndDropCommand ) {
    		DragAndDropCommand dnd = (DragAndDropCommand)cmd;
    		if( dnd.getId() == m_id ) {
    			addRedo(cmd);	// add this undo command after the current undo
    			dnd.m_id = null;
    			m_id = null;
    			rc = true;
    		}
    	}
    	return rc;
    }
}