/******************************************************************************
 * GViD Source Code Editor
 * Copyright (C) 2002  Alan Oursland
 * 
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * 
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 * 
 * Alan Oursland
 * alan@oursland.net
 *****************************************************************************/
package gvid.ui.editor.undo;

import gvid.undo.*;
import java.awt.Point;
import gvid.document.*;
import gvid.ui.editor.SourceCodeEditor;

public abstract class InsertDeleteCharBase 
	implements gvid.undo.UndoCommand {
	private String m_name = "";
	private SourceCodeModel m_model = null;
	protected char m_char = 0;
	protected Point m_doc = new Point();
	
	public InsertDeleteCharBase( String name, SourceCodeModel model, char c, Point doc ) {
		m_name = name;
		m_model = model;
		m_char = c;
		m_doc.x = doc.x;
		m_doc.y = doc.y;
	}
	
    public String getName() {
        return m_name;
    }

    public void setName(String name) {
        m_name = name;
    }

    public boolean isEditCmd() {
        return true;
    }

    protected void insertChar() {
    	m_model.insertChar(m_char, m_doc);
    }

    protected void deleteChar() {
    	m_model.deleteChar(m_doc);
    }
}