/******************************************************************************
 * GViD Source Code Editor
 * Copyright (C) 2002  Alan Oursland
 * 
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * 
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 * 
 * Alan Oursland
 * alan@oursland.net
 *****************************************************************************/
package gvid.ui.editor.undo;

import gvid.undo.*;
import gvid.document.*;

public abstract class InsertDeleteLineBase
	implements UndoCommand {
	private String m_name = "";	
	protected SourceCodeModel m_model = null;
	protected int m_row = 0;
	protected String m_str = "";
		
	public InsertDeleteLineBase( String name, SourceCodeModel model, int row, String str ) {
		m_name = name;
		m_model = model;
		m_row = row;
		m_str = str;
	}

    public String getName() {
    	return m_name;
    }

    public void setName( String name ) {
    	m_name = name;
    }

    public boolean isEditCmd() {
    	return true;
    }

    public boolean combineCommands( UndoCommand cmd ) {
    	boolean rc = false;
    	return rc;
    }
}