/******************************************************************************
 * GViD Source Code Editor
 * Copyright (C) 2002  Alan Oursland
 * 
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * 
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 * 
 * Alan Oursland
 * alan@oursland.net
 *****************************************************************************/
package gvid.ui.editor.undo;

import gvid.undo.*;

import gvid.ui.editor.*;
public class SelectionModeCommand 
	implements gvid.undo.UndoCommand {
	String m_name = "";
	int m_newMode = 0;
	int m_oldMode = 0;
		
	public SelectionModeCommand( String name, int newMode, int oldMode ) {
		m_name = name;
		m_newMode = newMode;
		m_oldMode = oldMode;
	}
		
    public boolean combineCommands(UndoCommand cmd) {
    	boolean rc = false;
    	if( cmd instanceof SelectionModeCommand ) {
    		rc = true;
    		m_newMode = ((SelectionModeCommand)cmd).m_newMode;
    	}
        return rc;
    }

    public String getName() {
        return m_name;
    }

    public boolean isEditCmd() {
        return false;
    }

    public void redo(SourceCodeEditor currentEditor) {
    	currentEditor.setSelectionMode(m_newMode);
    }

    public void setName(String name) {
    	m_name = name;
    }

    public void undo(SourceCodeEditor currentEditor) {
    	currentEditor.setSelectionMode(m_oldMode);
    }
}