/******************************************************************************
 * GViD Source Code Editor
 * Copyright (C) 2002  Alan Oursland
 * 
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * 
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 * 
 * Alan Oursland
 * alan@oursland.net
 *****************************************************************************/
package gvid.ui.menu;

import gvid.ui.menu.*;
import java.beans.*;
import gvid.command.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

public class FileMenuCommand 
	extends gvid.ui.menu.MenuCommand 
	implements ContainerListener {
	protected String m_nameBase = "";
	protected JDesktopPane m_desktop = null;
	public FileMenuCommand(String name, int mnemonic, int group, int cmd, CommandHandler cmdHandler, String desc, JDesktopPane desktop ) {
		super(name, mnemonic, group, cmd, cmdHandler, desc);
		m_nameBase = name;
		m_desktop = desktop;
		m_desktop.addContainerListener(this);
	}
	
	public void componentAdded(ContainerEvent e) {
		setMenuName();
	}
	
	public void componentRemoved(ContainerEvent e) {
		setMenuName();
	}
	
	private void setMenuName() {
		if( m_desktop.getComponentCount() > 0 ) {
			String filename = ((JInternalFrame)m_desktop.getComponent(0)).getTitle();
			setText(m_nameBase+" "+filename);
		} else {
			setText(m_nameBase);
		}
	}
}