/******************************************************************************
 * GViD Source Code Editor
 * Copyright (C) 2002  Alan Oursland
 * 
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * 
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 * 
 * Alan Oursland
 * alan@oursland.net
 *****************************************************************************/
package gvid.ui.menu;

import javax.swing.*;
import java.beans.*;
import java.awt.*;
import java.awt.event.*;
import gvid.command.*;

public class MenuCommand 
	extends 	javax.swing.JMenuItem 
	implements	java.awt.event.ActionListener,
				java.awt.event.MouseListener {
	int m_grpId = -1;
	int m_cmdId = -1;
	CommandHandler m_cmdHandler = null;
	String m_desc;
	
	public MenuCommand(String name, int mnemonic, int group, int cmd, CommandHandler cmdHandler, String desc ) {
		super(name, mnemonic);
		addActionListener(this);
		addMouseListener(this);
		m_grpId = group;
		m_cmdId = cmd;
		m_cmdHandler = cmdHandler;
		m_desc = desc;
	}
///////////////////////////////////////////////////////////////////////////////
//	ActionListener
	public void actionPerformed(ActionEvent e) {
		m_cmdHandler.executeCommand(m_grpId, m_cmdId);
	}
//	ActionListener
///////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////
//	MouseListener
    public void mouseClicked(MouseEvent e) {
    }
    public void mousePressed(MouseEvent e) {
    }
    public void mouseReleased(MouseEvent e) {
    }
    public void mouseEntered(MouseEvent e) {
    	m_cmdHandler.getStatusSource().setStatusMsg(m_desc);
    }
    public void mouseExited(MouseEvent e) {
    	m_cmdHandler.getStatusSource().setStatusMsg("");
    }
//	MouseListener
///////////////////////////////////////////////////////////////////////////////
}