/******************************************************************************
 * GViD Source Code Editor
 * Copyright (C) 2002  Alan Oursland
 * 
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * 
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 * 
 * Alan Oursland
 * alan@oursland.net
 *****************************************************************************/
package gvid.ui.menu;

import java.beans.*;
import javax.accessibility.*;
import java.awt.*;
import javax.swing.*;

public class MenuFocusReturn 
	implements java.beans.PropertyChangeListener {
    public void propertyChange(PropertyChangeEvent evt) {
    	if( evt.getPropertyName().equals( AccessibleContext.ACCESSIBLE_STATE_PROPERTY ) ) {
    		if( ( evt.getOldValue() != null ) && 
    			( evt.getOldValue() == AccessibleState.ARMED ) &&
    			( evt.getNewValue() == null ) ) {
    			Component p = (Component)evt.getSource();
    			boolean bContinue = true;
    			while( bContinue ) {
    				if( p.getParent() != null ) {
    					p = p.getParent();
    					if( p instanceof JMenuItem ) {
    						if( ((JMenuItem)p).isArmed() ) {
    							bContinue = false;
    						}
    					} else if( !(p instanceof JMenuBar ) ) {
    						bContinue = false;
    					}
    				} else {
    					bContinue = false;
    				}
    			}
    			p.requestFocus();
    		}
    	}
    }
}